CREATE OR REPLACE
PROCEDURE EXP_ITEMPRODUTO_NGD
IS
  V_CHAVE        VARCHAR2(300);
  V_ERRO         VARCHAR2(300);
  V_IDPESQITEM   VARCHAR2(300);
  V_CONTADOR     FLOAT := 0;
BEGIN
   FOR C_ITEMPRODUTO IN
      /*AVISAR PARA NEOGRID QUE SER NECESSRIO CONSULTA A TABELA USR_ITEMPRODUTO_NGD COM SUM(QTITEMPROD) SEM CDFILIAL E NRLANCTONF
        PARA NO HAVER REGISTROS DUPLICADOS*/
      (SELECT NOTAFISCAL.CDFILIEMIT, NOTAFISCAL.CDFILIRECE, PRODUTO.CDARVPROD, TO_CHAR(NOTAFISCAL.DTENTRSAID, 'YYYYMMDD') DTENTRSAID,
              SUM(QTITEMPROD) QTITEMPROD, 0 QTESTONO, AVG(VRUNITITEM) VRUNITITEM, 0 VRMARGEM, SUBSTR(FILIALRECE.NMFILIAL, 1, 20) NMFILIRECE,
              DTENTRSAID DTENTRSAIDORIG, PRODUTO.CDPRODUTO, ITEMPRODUTO.CDFILIAL, ITEMPRODUTO.NRLANCTONF
         FROM NOTAFISCAL, ITEMPRODUTO, FILIAL FILIALRECE, FILIAL FILIALEMIT, PRODUTO
        WHERE NOTAFISCAL.CDFILIAL    = ITEMPRODUTO.CDFILIAL
          AND NOTAFISCAL.NRLANCTONF  = ITEMPRODUTO.NRLANCTONF
          AND NOTAFISCAL.CDFILIEMIT  = FILIALEMIT.CDFILIAL
          AND NOTAFISCAL.CDFILIRECE  = FILIALRECE.CDFILIAL
          AND ITEMPRODUTO.CDPRODUTO  = PRODUTO.CDPRODUTO
          AND NOTAFISCAL.IDENTRSAIDOP = 'S'
          AND NOTAFISCAL.IDSTATUSNFE = 'A'
          AND NVL(FILIALRECE.IDCNTRRESC, 'N')   <> 'S'
          AND NVL(FILIALRECE.IDFUNCAOFILI, 'T') <> 'O'
          AND NVL(FILIALEMIT.IDCNTRRESC, 'N')   <> 'S'
          AND NVL(FILIALEMIT.IDFUNCAOFILI, 'T') = 'O'
          AND NVL(ITEMPRODUTO.USR_NGD_INTEGRADO, 'N') = 'N'
          AND NOTAFISCAL.DTENTRSAID >= (LAST_DAY(ADD_MONTHS(SYSDATE, -37)))+1
          AND ((NVL(PRODUTO.IDPRODATIVPR, 'N') = 'S') OR (INSTR(PRODUTO.NMPRODUTO, 'INATIVO') = 0))
        GROUP BY NOTAFISCAL.CDFILIEMIT, NOTAFISCAL.CDFILIRECE, PRODUTO.CDARVPROD, DTENTRSAID,
                 TO_CHAR(NOTAFISCAL.DTENTRSAID, 'YYYYMMDD'), SUBSTR(FILIALRECE.NMFILIAL, 1, 20),
                 PRODUTO.CDPRODUTO, ITEMPRODUTO.CDFILIAL, ITEMPRODUTO.NRLANCTONF)
   LOOP
      V_CONTADOR := V_CONTADOR + 1;
      IF V_CONTADOR >= 500 THEN
         V_CONTADOR := 0;
         COMMIT;
      END IF;
      SELECT NVL(MAX(USR_ITEMPRODUTO_NGD.CDARVPROD||USR_ITEMPRODUTO_NGD.CDFILIEMIT||
                     USR_ITEMPRODUTO_NGD.CDFILIRECE||USR_ITEMPRODUTO_NGD.DTENTRSAID ), '')
        INTO V_CHAVE
        FROM USR_ITEMPRODUTO_NGD
       WHERE USR_ITEMPRODUTO_NGD.CDARVPROD    = C_ITEMPRODUTO.CDARVPROD
         AND USR_ITEMPRODUTO_NGD.CDFILIEMIT   = C_ITEMPRODUTO.CDFILIEMIT
         AND USR_ITEMPRODUTO_NGD.CDFILIRECE   = C_ITEMPRODUTO.CDFILIRECE
         AND USR_ITEMPRODUTO_NGD.DTENTRSAID   = C_ITEMPRODUTO.DTENTRSAID
         AND USR_ITEMPRODUTO_NGD.CDFILIAL     = C_ITEMPRODUTO.CDFILIAL
         AND USR_ITEMPRODUTO_NGD.NRLANCTONF   = C_ITEMPRODUTO.NRLANCTONF;

      BEGIN
         IF V_CHAVE = '' THEN
            INSERT
             INTO USR_ITEMPRODUTO_NGD(CDFILIEMIT, CDFILIRECE, CDARVPROD, DTENTRSAID, CDFILIEMIT1,
                                      QTITEMPROD, QTESTONO, VRUNITITEM, VRMARGEM, NMFILIRECE,
                                      IDSTATUSITMNF, TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS,
                                      CDFILIAL, NRLANCTONF)
            VALUES (C_ITEMPRODUTO.CDFILIEMIT, C_ITEMPRODUTO.CDFILIRECE, C_ITEMPRODUTO.CDARVPROD, C_ITEMPRODUTO.DTENTRSAID, C_ITEMPRODUTO.CDFILIEMIT,
                    C_ITEMPRODUTO.QTITEMPROD, C_ITEMPRODUTO.QTESTONO, C_ITEMPRODUTO.VRUNITITEM, C_ITEMPRODUTO.VRMARGEM, C_ITEMPRODUTO.NMFILIRECE,
                    'ATIVO',	'I', 	SYSDATE,	NULL,	'1', C_ITEMPRODUTO.CDFILIAL, C_ITEMPRODUTO.NRLANCTONF);
         ELSE
            UPDATE USR_ITEMPRODUTO_NGD
               SET QTITEMPROD         = C_ITEMPRODUTO.QTITEMPROD,
                   VRUNITITEM         = C_ITEMPRODUTO.VRUNITITEM,
                   TPINTERFACE        = 'A',
                   DTINTERFACEORI     = SYSDATE,
                   DTINTERFACEDEST    = NULL,
                   STATUS             = '1'
             WHERE USR_ITEMPRODUTO_NGD.CDARVPROD    = C_ITEMPRODUTO.CDARVPROD
               AND USR_ITEMPRODUTO_NGD.CDFILIEMIT   = C_ITEMPRODUTO.CDFILIEMIT
               AND USR_ITEMPRODUTO_NGD.CDFILIRECE   = C_ITEMPRODUTO.CDFILIRECE
               AND USR_ITEMPRODUTO_NGD.DTENTRSAID   = C_ITEMPRODUTO.DTENTRSAID
               AND USR_ITEMPRODUTO_NGD.CDFILIAL     = C_ITEMPRODUTO.CDFILIAL
               AND USR_ITEMPRODUTO_NGD.NRLANCTONF   = C_ITEMPRODUTO.NRLANCTONF;
         END IF;
         V_IDPESQITEM := C_ITEMPRODUTO.CDARVPROD||'-'||C_ITEMPRODUTO.CDFILIEMIT||'-'||C_ITEMPRODUTO.CDFILIRECE||'-'||C_ITEMPRODUTO.DTENTRSAID;
         UPDATE USR_LOG_NGD
            SET DTLOG      = SYSDATE,
                STATUS     = '0',
                OBSSTATUS  = NULL
          WHERE IDPROCESSO = 'USR_ITEMPRODUTO_NGD'
            AND IDPESQITEM = V_IDPESQITEM;
         IF SQL%NOTFOUND THEN
            INSERT
              INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
            VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '0', NULL, V_IDPESQITEM);
         END IF;   
         UPDATE ITEMPRODUTO
            SET USR_NGD_INTEGRADO = 'S'
          WHERE ITEMPRODUTO.CDFILIAL    = C_ITEMPRODUTO.CDFILIAL
            AND ITEMPRODUTO.NRLANCTONF  = C_ITEMPRODUTO.NRLANCTONF
            AND ITEMPRODUTO.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO
            AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
      EXCEPTION
         WHEN OTHERS THEN BEGIN
            V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
            V_IDPESQITEM := C_ITEMPRODUTO.CDARVPROD||'-'||C_ITEMPRODUTO.CDFILIEMIT||'-'||C_ITEMPRODUTO.CDFILIRECE||'-'||C_ITEMPRODUTO.DTENTRSAID;
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '1',
                   OBSSTATUS  = V_ERRO
             WHERE IDPROCESSO = 'USR_ITEMPRODUTO_NGD'
               AND IDPESQITEM = V_IDPESQITEM;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
            END IF;
         END;
      END;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_ITEMPRODUTO_NGD','6.39.030'); END;
/
